#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLEN 512

/* restituisce il numero di volte in cui find e` stato sostituito 
 * con replace
 */
int sostituisci(char sin[], char find[], char replace[]);

int main()
{
	char s[MAXLEN];
	char trova[64];
	char sost[64];

	int nsost;

	printf("Inserisci la frase:\n");

	fgets(s, MAXLEN, stdin);

	printf("Inserisci la parola da cercare: ");
	fgets(trova, 64, stdin);
	trova[strlen(trova) - 1] = '\0';
	printf("Inserisci la parola da sostituire: ");
	fgets(sost, 64, stdin);
	sost[strlen(sost) - 1] = '\0';

	nsost = sostituisci(s, trova, sost);

	printf("La nuova frase e`:\n%s\n", s);
	printf("\nSono state eseguite %d sostituzioni.\n", nsost);
}

int sostituisci(char *s, char *f, char *r)
{
	char dest[MAXLEN];
	int i = 0, j = 0;
	int numero_sostituzioni = 0;

	dest[i] = '\0';

	while(i < strlen(s) && j < MAXLEN)
	{
		if(strncmp(s + i, f, strlen(f)) == 0 && j + strlen(r) < MAXLEN - 1)
		{
			strcpy(dest + j, r);
			j += strlen(r);
			i += strlen(f);
			dest[j] = '\0';
			numero_sostituzioni++;
		}
		else
		{
			dest[j] = s[i];
			i++;
			j++;
		}
		dest[j] = '\0';
	}
	/* salvo in s la nuova stringa */
	strcpy(s, dest);
	return numero_sostituzioni;
}


